declare const _default: {
    name: string;
    props: {
        items: {
            type: ArrayConstructor;
            required: boolean;
        };
        keyField: {
            type: StringConstructor;
            default: string;
        };
        direction: {
            type: StringConstructor;
            default: string;
            validator: (value: any) => boolean;
        };
        listTag: {
            type: StringConstructor;
            default: string;
        };
        itemTag: {
            type: StringConstructor;
            default: string;
        };
        itemSize: {
            type: NumberConstructor;
            default: null;
        };
        gridItems: {
            type: NumberConstructor;
            default: undefined;
        };
        itemSecondarySize: {
            type: NumberConstructor;
            default: undefined;
        };
        minItemSize: {
            type: (StringConstructor | NumberConstructor)[];
            default: null;
        };
        sizeField: {
            type: StringConstructor;
            default: string;
        };
        typeField: {
            type: StringConstructor;
            default: string;
        };
        buffer: {
            type: NumberConstructor;
            default: number;
        };
        pageMode: {
            type: BooleanConstructor;
            default: boolean;
        };
        prerender: {
            type: NumberConstructor;
            default: number;
        };
        emitUpdate: {
            type: BooleanConstructor;
            default: boolean;
        };
        updateInterval: {
            type: NumberConstructor;
            default: number;
        };
        skipHover: {
            type: BooleanConstructor;
            default: boolean;
        };
        listClass: {
            type: (ObjectConstructor | StringConstructor | ArrayConstructor)[];
            default: string;
        };
        itemClass: {
            type: (ObjectConstructor | StringConstructor | ArrayConstructor)[];
            default: string;
        };
        itemsLimit: {
            type: NumberConstructor;
            default: number;
        };
        xm_mode: StringConstructor;
        xm_mode_root: BooleanConstructor;
        xm_template: (ObjectConstructor | FunctionConstructor)[];
        xm_renderless: FunctionConstructor;
        xm_theme: StringConstructor;
        xm_chart_theme: ObjectConstructor;
    };
    setup(props: any, context: any): () => import("@vue/runtime-core").VNode<import("@vue/runtime-core").RendererNode, import("@vue/runtime-core").RendererElement, {
        [key: string]: any;
    }>;
};
export default _default;
